﻿using System;
using UnityEngine;
using System.Text;

using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using MacGruber;
using Random = UnityEngine.Random;

namespace SPQR
{
    public class SPQRPerformance : MVRScript {

        private EventTrigger myEventTrigger;
        int titles = 0;

        protected JSONStorableString myString;
        JSONStorableFloat PhysicsUpdateFPS;
    
        public override void Init()
        {
            Utils.OnInitUI(CreateUIElement);


            CreateTitle("PERFORMANCE TWEAKS",40,false);
            CreateTitle("AETERNUM TOOLS",30,true);
            
            


            JSONStorableString jstring = new JSONStorableString("instructions2", "\n Setting it to a lower value will improve performance and will make the physics a bit more choppier. Increasing it will cost performance and should improve the physics. ");
            UIDynamicTextField dtext = CreateTextField(jstring, true);
            dtext.UItext.supportRichText = true;
            dtext.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext.height = 350f;

            JSONStorableString jstring2 = new JSONStorableString("instructions1", "\n This plugin updates the rate per second at which the physics update in VAM.");
            UIDynamicTextField dtext2 = CreateTextField(jstring2);
            dtext2.UItext.supportRichText = true;
            dtext2.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext2.height = 350f;
            


            myEventTrigger = new EventTrigger(this, "OnTrigger");
            // Utils.SetupButton(this, "Actions OnTrigger", myEventTrigger.OpenPanel, false);

            // Utils.SetupButton(this, "Test Trigger", TestTrigger, true);
            Utils.SetupAction(this, "Trigger", Trigger);
            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
            SimpleTriggerHandler.LoadAssets();


            Utils.SetupSpacer(this, 50, false);
            Utils.SetupSpacer(this, 50, true);

            PhysicsUpdateFPS = new JSONStorableFloat("Physics Update FPS",  72f, PhysicsUpdateFPSCallback, 10f, 144f, true);
            PhysicsUpdateFPS.storeType = JSONStorableParam.StoreType.Full;
            RegisterFloat(PhysicsUpdateFPS);
            CreateSlider(PhysicsUpdateFPS, false);

            // myString = new JSONStorableString("myString", "", UpdateMyString);
            // RegisterString(myString);
            // UIDynamicLabelInput myStringInput = Utils.SetupTextInput(this, "My String", myString, false);

            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
            UIUpdate();
        }
        private void OnAtomRename(string oldid, string newid)
        {
            myEventTrigger.SyncAtomNames();
        }
        private void UIUpdate()
        {
        }


        void Start()
        {

            // Time.fixedDeltaTime = 0.08f;
            try
            {
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void Update()
        {
            try
            {
                myEventTrigger.Update();
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        private void TestTrigger()
        {
            var jc = this.GetJSON(true, true, false);
            //SuperController.LogMessage("current : " + jc.ToString().Replace("\"", "\\\""));

        }
        private void Trigger()
        {
            myEventTrigger.Trigger();
        }

        void FixedUpdate()
        {
            try
            {
                // put code in here
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void OnDestroy()
        {
            SuperController.singleton.onAtomUIDRenameHandlers -= OnAtomRename;
            myEventTrigger.Remove();
            Utils.OnDestroyUI();
            Time.fixedDeltaTime = 0.01388889f;
            //SuperController.LogMessage("val reset :"+Time.fixedDeltaTime);
        }



        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
            if (includePhysical || forceStore)
            {
                needsStore = true;
                jc[myEventTrigger.Name] = myEventTrigger.GetJSON(base.subScenePrefix);
            }
            return jc;
        }

        public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
            base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);

            if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
            {
                myEventTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
            }
        }



        //////////////////////////////////////////////

        private void CreateTitle(string text, int fontsize, bool right,int spacing){
            CreateTitle(text, fontsize, right);
            Utils.SetupSpacer(this, spacing, right);
        }
        private void CreateTitle(string text, int fontsize, bool right){
                JSONStorableString title1 = new JSONStorableString("title"+(++titles), "\n<size="+fontsize+"><b>"+text+"</b></size>");
                UIDynamicTextField title1text = CreateTextField(title1, right);
                title1text.UItext.supportRichText = true;
                title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
                title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                title1text.height = 100f;
                title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

        void UpdateMyString(string name)
        {
        }

        void PhysicsUpdateFPSCallback(float val){
            Time.fixedDeltaTime = 1/val;
            //SuperController.LogMessage("val:"+1/val);
        }


	}
}